/*****************************************************************************
 *
 * File ..................: basics.c
 * Purpose ...............: Basic functions
 * Last modification date : 04-May-2001
 *
 *****************************************************************************
 * Copyright (C) 2001
 *
 * Darryl Perry		FIDO:		1:211/105
 * Sacramento, CA.
 * USA
 *
 * This file is part of TopDoor/LNX.
 *
 * This utility is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * TopDoor/LNX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along TopDoor/LNX; see the file COPYING.  If not, write to the
 * Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include "basics.h"
#include "mci.h"
#include "conio.h"

void nl()
{
	mci("\n");
}

void paws()
{
	mci("~SM[PAUSE]");
	od_get_key(TRUE);
	mci("\b\b\b\b\b\b\b`0F");
}


int yesno()
{
	char ch;
	int x=FALSE;

	mci(" (Y/n): ");
	ch=od_get_answer("YN\n\r");
	if(ch=='Y' || ch=='\n' || ch=='\r' ) x=TRUE;
	return(x);
}

int noyes()
{
	char ch;
	int x=FALSE;

	mci(" (y/N): ");
	ch=od_get_answer("YN\n\r");
	if(ch=='N' || ch=='\n' || ch=='\r') x=TRUE;
	return(x);
}

int printfile(char *fname) 
{
	FILE *fptr;
	int done=FALSE,cnt=0,x=FALSE;
	char ttxt[161],ch;

	fptr=fopen(fname,"rt");
	if(fptr!=NULL){
		while(fgets(ttxt,161,fptr)!=NULL && !done){
			mci(ttxt);
			cnt++;
			if(cnt>=20){
				mci("~SMMore? (Y/n/c): ");
				ch=od_get_answer("YNC");
				if(ch=='Y')
					cnt=0;
				else
					done=TRUE;
				}
			}
		x=TRUE;
		}

	fclose(fptr);
	return(x);
}

void strupr(char *text)
{
	int i;
	for(i=0;i<strlen(text);i++)
		if(text[i]>='a' && text[i]<='z')
			text[i]-=32;
}

void strlwr(char *text)
{
	int i;
	for(i=0;i<strlen(text);i++)
		if(text[i]>='A' && text[i]<='Z')
			text[i]+=32;
}

void center(char *text)
{
	int i;
	

	for(i=0;i<(40-(mcistrlen(text)/2));i++)
		printf(" ");
	mci(text);
}

char moreyn()
{
	char ch;
	int i,s;

	mci("~SMMore? (Y/n): ");
	for(i=0;i<s;i++){
		printf("\b \b");
		}
	if(ch=='\n')	{
		ch='Y';
		}
	return(ch);
}

int mcistrset(char *mcstr, int chop)
{
	int i,x;

	i=strlen(mcstr);	
	if(mcistrlen(mcstr)>chop){
		for(x=0;x<chop;x++){
			if(mcstr[x]=='`'){
				chop+=3;
				}
			}
		if(x<i)	mcstr[x]='\0';
		}
	else{
		for(x=mcistrlen(mcstr);x<chop;x++){
			strcat(mcstr," ");
			}
		}
	return 0;
}

int mcistrrset(char *mcstr, int chop)
{
	int i,x;
	char t1[191];

	i=strlen(mcstr);	
	if(mcistrlen(mcstr)>chop){
		for(x=0;x<chop;x++){
			if(mcstr[x]=='`'){
				chop+=3;
				}
			}
		if(x<i)	mcstr[x]='\0';
		}
	else{
		*t1='\0';
		for(x=mcistrlen(mcstr);x<chop;x++){
			strcat(t1," ");
			}
		strcat(t1,mcstr);
		strcpy(mcstr,t1);
		}
	return 0;
}

int mcistrcset(char *mcstr, int chop)
{
	int i,x,num,num1;
	char t1[191];

	i=strlen(mcstr);	
	if(mcistrlen(mcstr)>chop){
		for(x=0;x<chop;x++){
			if(mcstr[x]=='`'){
				chop+=3;
				}
			}
		if(x<i)	mcstr[x]='\0';
		}
	else{
		num=chop-mcistrlen(mcstr);  /*  How many total blanks */
		num1=(num/2);  /* How many blanks in front */
		*t1='\0';
		for(x=0;x<num1;x++){
			strcat(t1," ");
			}
		strcat(t1,mcstr);
		for(x=num1;x<num;x++){   /* How many blanks in back */
			strcat(t1," ");
			}
		strcpy(mcstr,t1);
		}
	return 0;
}
