/*****************************************************************************
 * File ..................: mci.c
 * Purpose ...............: Formatted output routines 
 * Last modification date : 15-Mar-2001
 *****************************************************************************
 * Copyright (C) 2001
 *
 * Darryl Perry		FIDO:		1:211/105
 * Sacramento, CA.
 * USA
 *
 * This file is part of TopDoor/LNX.
 *
 * This utility is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * TopDoor/LNX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along TopDoor/LNX; see the file COPYING.  If not, write to the
 * Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/
#include "conio.h"
#include "mci.h"
#include "basics.h"
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

char fstr[41];
char A[10][128];
char retstr[128];
char *comma(long cval);
char ttxtx[41];

void mciEseries(char *ttxt)
{
	char *p,t1[512],ch=0,dump[41];
	int i,num=0,num1=0;

	while(strstr(ttxt,"~EC"))	strrepl(ttxt,500,"~EC","\x1b[");

	while((p=strstr(ttxt,"~EE"))){  /*  Create pattern of spaces to len n */
		if(isdigit(*(p+3))){
			num=*(p+3)-'0';
			}
		if(isdigit(*(p+4))){
			num*=10;
			num+= (*(p+4)-'0');
			}

		for(num1=0;num1<num;num1++) t1[num1]=' ';

		t1[num1]='\0';
		sprintf(dump,"~EE%c%d",ch,num);
		strrepl(ttxt,500,dump,t1);
		}
	
	while((p=strstr(ttxt,"~EF"))){    /*  Create fill pattern of c to len n */
		ch=*(p+3); 
		if(isdigit(*(p+4))){
			num=*(p+4)-'0';
			}
		if(isdigit(*(p+5))){
			num*=10;
			num+= (*(p+5)-'0');
			}

		for(num1=0;num1<num;num1++) t1[num1]=ch;

		t1[num1]='\0';
		sprintf(dump,"~EF%c%d",ch,num);
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~EL"))){
		i=3;num=0;
		while(isdigit( *(p+i) ) ){
			num=(num*10) + (*(p+i)-'0');
			i++;
			}
		
		t1[0]=*(p+i); i++; 
		t1[1]=*(p+i); i++;
		t1[2]=*(p+i); i++;
		t1[3]='\0';

		sprintf(dump,"~EL%d%s",num,t1);
		mcimacros(t1);
		mcistrset(t1,num);
		strrepl(ttxt,500,dump,t1);
		}
	
	while((p=strstr(ttxt,"~EK"))){  /* Center & Justify, expand to n */
		dump[0]=*(p+3); dump[1]=*(p+4); dump[2]='\0'; num=atoi(dump);
		t1[0]=*(p+5); t1[1]=*(p+6); t1[2]=*(p+7); t1[3]='\0';

		sprintf(dump,"~EK%d%s",num,t1);
		mcimacros(t1);
		mcistrcset(t1,num);
		strrepl(ttxt,500,dump,t1);
		}
	while((p=strstr(ttxt,"~EN"))){  /* Strip all spaces*/
		t1[0]=*(p+3); t1[1]=*(p+4); t1[2]=*(p+5); t1[3]='\0';

		sprintf(dump,"~EN%s",t1);
		mcimacros(t1);
		while(strstr(t1," "))	strrepl(t1,500," ","");
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~ER"))){
		i=3;num=0;
		while(isdigit( *(p+i) ) ){
			num=(num*10) + (*(p+i)-'0');
			i++;
			}

		t1[0]=*(p+i); i++;
		t1[1]=*(p+i); i++;
		t1[2]=*(p+i); i++;
		t1[3]='\0';

		sprintf(dump,"~ER%d%s",num,t1);
		mcimacros(t1);
		mcistrrset(t1,num);
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~EU"))){  /* Convert to upper case */
		t1[0]=*(p+3); t1[1]=*(p+4); t1[2]=*(p+5); t1[3]='\0';

		sprintf(dump,"~EU%s",t1);
		mcimacros(t1);
		strupr(t1);
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~EW"))){  /* Convert to lower case */
		t1[0]=*(p+3); t1[1]=*(p+4); t1[2]=*(p+5); t1[3]='\0';

		sprintf(dump,"~EW%s",t1);
		mcimacros(t1);
		strlwr(t1);
		strrepl(ttxt,500,dump,t1);
		}
	while((p=strstr(ttxt,"~ES"))){
		ttxt[p-ttxt]='\0';
		mcicolor(p+3,FALSE);
		strcat(ttxt,p+3);
		}
}


void mciAnd(char *ttxt)
{
	while(strstr(ttxt,"~&1"))	strrepl(ttxt,500,"~&1",A[1]);
	while(strstr(ttxt,"~&2"))	strrepl(ttxt,500,"~&2",A[2]);
	while(strstr(ttxt,"~&3"))	strrepl(ttxt,500,"~&3",A[3]);
	while(strstr(ttxt,"~&4"))	strrepl(ttxt,500,"~&4",A[4]);
	while(strstr(ttxt,"~&5"))	strrepl(ttxt,500,"~&5",A[5]);
	while(strstr(ttxt,"~&6"))	strrepl(ttxt,500,"~&6",A[6]);
	while(strstr(ttxt,"~&7"))	strrepl(ttxt,500,"~&7",A[7]);
	while(strstr(ttxt,"~&8"))	strrepl(ttxt,500,"~&8",A[8]);
	while(strstr(ttxt,"~&9"))	strrepl(ttxt,500,"~&9",A[9]);
}

void mciOseries(char *ttxt)
{

}


void mciPseries(char *ttxt)
{

}

void mcimacros(char *ttxt)
{
	if(strstr(ttxt,"~&"))	mciAnd(ttxt);
	if(strstr(ttxt,"~O"))	mciOseries(ttxt);
	if(strstr(ttxt,"~P"))	mciPseries(ttxt);
}


char *strrepl(char *Str, size_t BufSiz, char *OldStr, char *NewStr)
{
	int OldLen, NewLen;
	char *p, *q;

	if(NULL == (p = strstr(Str, OldStr)))
		return Str;
	OldLen = strlen(OldStr);
	NewLen = strlen(NewStr);
	if ((strlen(Str) + NewLen - OldLen + 1) > BufSiz)
		return NULL;
	memmove(q = p+NewLen, p+OldLen, strlen(p+OldLen)+1);
	memcpy(p, NewStr, NewLen);
	return q;
}

void mci(char *strng, ...)
{
	char s[512],ttxt[512];
	va_list ap;

	va_start(ap,strng);
	vsprintf(s,strng,ap);
	va_end(ap);
	strcpy(ttxt,s);

	if(ttxt[0]=='@'){
		printfile(ttxt+1);	
		return;
		}
	mciEseries(ttxt);
	mcimacros(ttxt);
	mciansi(ttxt);
	mcicolor(ttxt,TRUE);
	mcihidden(ttxt);
	mcifuncts(ttxt);
}

void MciNoColor(char *strng, ...)
{
	char s[512],ttxt[512];
	va_list ap;

	va_start(ap,strng);
	vsprintf(s,strng,ap);
	va_end(ap);
	strcpy(ttxt,s);
	mcimacros(ttxt);
	mcihidden(ttxt);
	mcifuncts(ttxt);
}

void MciNoHidden(char *strng, ...)
{
	char s[512],ttxt[512];
	va_list ap;

	va_start(ap,strng);
	vsprintf(s,strng,ap);
	va_end(ap);
	strcpy(ttxt,s);
	mcimacros(ttxt);
	mcicolor(ttxt,TRUE);
	printf(ttxt);
}

int mcistrlen(char *ttxt)
{
	int i,count;

	count=strlen(ttxt);
	for(i=0;i<strlen(ttxt);i++) {
		if(ttxt[i]=='`'){
			count-=3;
			}
		}
	return(count);
}

int mcistrlenH(char *ttxt)
{
	int i,count;

	count=strlen(ttxt);
	for(i=0;i<strlen(ttxt);i++) {
		if(ttxt[i]=='`'){
			count-=3;
			}
		}
	return(count);
}

int oct2dec(char oct)
{
	int x=0;
	if(isdigit(oct))	x=oct-'0';	
	if(isalpha(oct))	x=oct-'A'+10;
	return(x);
}

void mcicolor(char *ttxt, int onoff)
{
	char *p;
	char mcistr[5];
	char outstr[21];
	int FG,BG,IN,BK,co[8]={0,4,2,6,1,5,3,7};

	while((p=strchr(ttxt,'`'))){
		if(isdigit(*(p+1)) || (*(p+1)>='A' && *(p+1)<='F') ){
			mcistr[0]='`';
			mcistr[1]=*(p+1);
			mcistr[2]=*(p+2);
			mcistr[3]='\0';

			FG=BG=IN=BK=0;


			/* Deal with the background first */
			BG=oct2dec(mcistr[1]);
			if(BG>7){ BG-=8; BK=1; }
			FG=oct2dec(mcistr[2]);
			if(FG>7){ FG-=8; IN=1; }

			/* if onoff==TRUE, replace MCI codes with ANSI color */
			/* if onoff==FALSE, strip out the MCI codes */
			if(onoff){  
				if(BK)	
					sprintf(outstr,"\x1b[%d;%d;%d;%dm",
						IN,BK*5,co[FG]+30,co[BG]+40);
				else
					sprintf(outstr,"\x1b[%d;%d;%dm",
						IN,co[FG]+30,co[BG]+40);
				}
			else
				strcpy(outstr,"");
			strrepl(ttxt,500,mcistr,outstr);
			}
		else
			{
			/* replace ` with ' if it is not part of an MCI code */
			strrepl(ttxt,500,"`","'");
			}
		}

}

void mcihidden(char *ttxt)
{
	while(strstr(ttxt,"~SM"))	strrepl(ttxt,500,"~SM","\n");
	while(strstr(ttxt,"~SC"))	{
		strrepl(ttxt,500,"~SC","\x1b[2J\x1b[1;1H"); 
		}
}

void mciansi(char *ttxt)
{	
	char in[5],out[5];

	sprintf(in,"%c",148);	sprintf(out,"%c",205);
	while(strstr(ttxt,in))	strrepl(ttxt,500,in,out);

	sprintf(in,"%c",128);	sprintf(out,"%c",187);
	while(strstr(ttxt,in))	strrepl(ttxt,500,in,out);
}

void mcifuncts(char *ttxt)
{
	int cnt=0;
	while(strstr(ttxt,"~SP"))	{
		strrepl(ttxt,500,"~SP","");
		cnt++;
		}
	printf(ttxt);
	while(cnt){
		paws();
		cnt--;
		}
}

char *ansic(unsigned char colrnum)
{
	int FG, BG;

	/* Break down each nibble */
	/* Left (high order), and Right */
	BG= ((colrnum & 0x00F0) >> 4);
	FG=  (colrnum & 0x000F);

	sprintf(fstr,"`%X%X",BG,FG);
	return(fstr);
}

void stripCR(char *ostr)
{
	while(strchr(ostr,'\n')) strrepl(ostr,500,"\n","");
	while(strchr(ostr,'\r')) strrepl(ostr,500,"\r","");
	while(strchr(ostr,'\b')) strrepl(ostr,500,"\b","");
	while(strchr(ostr,'\x1b')) strrepl(ostr,500,"\x1b","");
}
void stripSC(char *ttxt)
{
	while(strstr(ttxt,"~SC"))	strrepl(ttxt,500,"~SC","");
}

void char2A(int numa, char *ttxt)
{
	strcpy(A[numa],ttxt);
}

void int2A(int numa, int num)
{
	sprintf(A[numa],"%d",num);
}

void long2A(int numa, long lnum)
{
	sprintf(A[numa],"%ld",lnum);
}
